//==============================================================
// BGMt@CĐ
//--------------------------------------------------------------

#ifndef __FV_BGM_H__
#define __FV_BGM_H__

#include "fvView.h"

typedef struct {
	int				imageType;									// ߍ݉摜̎ށiEXT_TYPE_JPG ...j
	char			mime[16];									// ߍ݉摜MIME^Cv
	int				picType;									// 摜̎ʁi3:frontCover 4:backCover ...j
	unsigned char	*descText;									// 摜̐
	unsigned char	*data;										// ߍ݉摜̈kf[^
	long			dataSize;									// kf[^TCY
	void			*next;										// ̖ߍ݉摜Ǘ\̂ւ̃|C^iNULL:j
	void			*back;										// O̖ߍ݉摜Ǘ\̂ւ̃|C^iNULL:j
} strBgmPic;													// ߍ݉摜Ǘ\

typedef struct {
	int				type;										// ̎ށi1:mp3 2:wavej
	int				bgmID;										// ȕύXʁiȂςCNgj
	int				tag;										// ^O̎ށi1:ID3v1 2:ID3v2.2 3:ID3v2.3 4:ID3v2.4j
	int				unsupport;									// Đ\i0:Yesj
	unsigned char	*title;
	unsigned char	*artist;
	unsigned char	*album;
	unsigned char	*year;
	unsigned char	*comment;
	unsigned int	pos;										// V[Nʒu
	unsigned int	time;										// Ȃ̒i1/100[s]Pʁj
	int				SamplingRate;								// TvO[g
	int				bitRate;									// rbg[g
	int				formatID;									// tH[}bgID
	int				avg;										// f[^x
	int				blockSize;									// ubNTCY
	int				bit;										// Tṽrbg
	unsigned int	samplingLength;								// `l̃Tv
	int				mLayer;										// C[i1 = Layer-V,  2 = Layer-U,  3 = Layer-Tj
	int				mID;										// 0 = MPEG2, 1 = MPEG1
	int				channel;									// `li0:XeI 1:WCgXeI 2:fA`l 3:mj
	int				vbr;										// σrbg[gi0:No 1:YESj
	unsigned int	frame;										// t[
	int				picCount;									// ߍ݉摜̌i0:摜Ȃj
	strBgmPic		*pic;										// ߍ݉摜\̂ւ̃|C^iNULL:摜Ȃj
	char			*info;										// ڍ׏
	char			etcTag[1024];								// 擾Ȃ^Oꗗ
} strBgm;

extern strBgm gBGM;

typedef struct {
	void	*next;
	char	*path;
} strPlaylistItem;												// vCXg̍ڃ`FC\

typedef struct {
	int				count;
	strPlaylistItem	*list;
} strPlaylist;													// vCXgǗ\

extern strPlaylist gPlaylist;


void bgmPropertyClear(strBgm *bgm, int reset);
int getMP3FileTag(SceUID fd, strBgm *bgm, long *start, long *end, int imgFlag);
int getWavFileTag(SceUID fd, strBgm *bgm, long *start, long *end, int imgFlag);
int audioInit(iniList *phase);
void audioTerm(void);
int audioPlay(const char *path, const char *name);
void audioStop(void);
void audioNext(void);
void audioBack(void);
void audioReplay(void);
int audioGetPlayMode(void);
char *getID3ApicType(int picType);
strBgmPic *getBgmApicData(char *bgmFile, char *inPath, strBgm *bgm, char *info);
int wavFileDecode(char *path, u32 **pcmData, u32 *pcmSize);

#endif
