//==============================================================
// Simple IME   (STPP.04)
//     for PSP CFW5.00 M33-6
// STEAR 2009
//--------------------------------------------------------------
// PSPp̊ȈIMECuB
// \tgEFAL[{[hƏnꊿϊƃ[U[i\ϊjB
//--------------------------------------------------------------

#ifndef SimpleIME_H
#define SimpleIME_H

#define SIME_KEY_UP			0x1E
#define SIME_KEY_DOWN		0x1F
#define SIME_KEY_LEFT		0x1D
#define SIME_KEY_RIGHT		0x1C
#define SIME_KEY_TRIANGLE	0x02
#define SIME_KEY_CROSS		0x1B
#define SIME_KEY_SQUARE		0x08
#define SIME_KEY_CIRCLE		0x0D
#define SIME_KEY_LTRIGGER	0x03
#define SIME_KEY_RTRIGGER	0x04
#define SIME_KEY_START		0x05
#define SIME_KEY_SELECT		0x06


//==============================================================
// t@C̓ǂݍ݂Ɗe평
//--------------------------------------------------------------
// flag      0:EBhEɔwi𕜌
//        ȊO:EBhEɉȂiCō悷ׂj
// ߂l    1:ɏĂ
//           0:̓ǂݍݐ
//          -1:sȎt@C
//          -2:Ȃ
//          -3:t@CJȂi݂ȂHj
//--------------------------------------------------------------
// t@CIMEݒǂݍ݂܂B
// ɏĂꍇ flag ̐ݒύX̂ݎs܂B
// ݒt@C͎t@CƓtH_ɔzu܂B
// [U[ǂ߂Ȃꍇ̌x͂܂B
//--------------------------------------------------------------

int		InitSIME(int flag);


//==============================================================
// I
//--------------------------------------------------------------
// ɕێĂt@Cɏ߂AJB
// sɓd؂铙Ɗ̕בւɔf܂B
// ܂AIMEf[^ݒt@Cɕۑ܂B
// ݒt@C̈ʒu͎t@CƓtH_ɂȂ܂A
// Ȃꍇ EBOOT.PBP ƓtH_ɂȂ܂B
//--------------------------------------------------------------

void	EndSIME(void);


///==============================================================
// tHgw
//--------------------------------------------------------------
// font   tHg
// cyw    tHg̍i16܂Łj
// ߂l w肷ÕtHg
//--------------------------------------------------------------
// ϊsɎgp镶tHgw肷B
// eEBhDɕ\镶͓_tHgɌŒB
//--------------------------------------------------------------

int SIMEfont(int font,int cyw);


//==============================================================
// J[\w
//--------------------------------------------------------------
// xw  J[\X̕i0ȉ:J[\\Ȃj
// x,y J[\ʒu
//--------------------------------------------------------------
// J[\Ww肷ϐƃJ[\`w肷B
// J[\\Sgets()sĂԁAXV܂B
// J[\I^ŁAY̑傫SIMEfont()Ŏw肵܂B
//--------------------------------------------------------------

void SIMEcursor(int xw,int x,int y);


//==============================================================
// ʍݒ
//--------------------------------------------------------------
// page sʃy[Wi01j
//--------------------------------------------------------------
// sʃy[Ww肵܂B
// sceGuDrawBuffer()Ƃ̐ݒ͍lĂ܂B
// VRAM̐擪c272hbgɃy[W0,1ƌߑłĂ܂B
// C̍dlɂĂ͎gȂƎv܂A͓̎K
// CׂB
//--------------------------------------------------------------

void SIMESetDraw(int page);


//==============================================================
// 
//--------------------------------------------------------------
// *str   ͂ꂽiő33oCg asciizj
// pad    pbh
// ߂l str̂
//--------------------------------------------------------------
// \tgL[{[hɂ镶̓́B
// ȉpIMEɂ銿ϊsB
// łȂJ[\L[̊e{^Rg[R[hƂĕԂB
// Rg[R[h̑ΉSgetchar()QƂĂB
// ͕́im肳ꂽꍇ́jstrɓĂ܂B
//--------------------------------------------------------------

char	*SIMEgets(char *str,SceCtrlData pad);


//==============================================================
// L[
//--------------------------------------------------------------
// pad    pbh
// ߂l 0:͂Ȃ
//        :0x1C :0x1D :0x1E :0x1F
//        :0x0Di[Enter]j ~:0x1Bi[Esc]j :0x08i[BS]j :0x02 L:0x03 R:0x04
//        [START]:0x05 [SELECT]:0x06
//--------------------------------------------------------------
// e{^̏ԂL[{[hȃL[s[gŎ擾B
// ̏ꍇ͍Ōɉ{^ɑΉR[hԂB
// ͕͂͂ȂǁAL[s[gŃL[͂sꍇȂǂ
// z肵ėpӂĂ܂B
//--------------------------------------------------------------

int		SIMEgetchar(SceCtrlData pad1);


//==============================================================
// J[\\
//--------------------------------------------------------------
// ch   -1FEBhEnƃJ[\
//       0FJ[\_ł
//    ȊOFJ[\/\Ȃ
//--------------------------------------------------------------
// SIMEgetchar()P̂ł̓J[\\sȂ߁AJ[\\ꍇ
// ɂgpB
// )
//   ch = SIMEgetchar(pad1);
//   SIMEDrawCursor(ch);
//
// ܂AL[Ƃ͕ʂɃEBhE̕\nꍇ-1w肷B
//--------------------------------------------------------------

void	SIMEDrawCursor(int ch);


//==============================================================
// VtgJIS̑P`FbN
//--------------------------------------------------------------
// ߂l  0:Pł͂Ȃ
//        -1:Pł
//--------------------------------------------------------------
// VtgJISȂKKvɂȂ̂ňꉞpӂƂ܂B
//--------------------------------------------------------------

int		chkSJIS(unsigned char cr);


//==============================================================
// ͐؂ւ
//--------------------------------------------------------------
// ime ̓\[Xi0:Simple IME ȊO:OSKj
// str ͂ꂽ
// pad pbh
//--------------------------------------------------------------
// ̓\[XSimple IMEOSKŐ؂ւ܂B
// OSKgpɉʃC[WҔobt@mۂłȂꍇ
// Simple IMEgp܂B
//--------------------------------------------------------------

void	SIMEselInput(int ime,char *str,SceCtrlData pad);



#endif
