//==============================================================
// ̑̃c[ނ낢
//--------------------------------------------------------------

#ifndef __FVTOOL_H__
#define __FVTOOL_H__

#include <pspkernel.h>
#include <pspctrl.h>
#include "freezeviewer.h"

// {ݒ
#define FILE_PATH		(512)
#define BUF_LENGTH		(256) // V[g
#define TMP_BUF_SIZE	(4096)
#define TRUNC			(PSP_O_WRONLY | PSP_O_CREAT | PSP_O_TRUNC)
#define APPEND			(PSP_O_WRONLY | PSP_O_CREAT | PSP_O_APPEND)
#define FILE_PARMISSION	(0777)

//----- gq -----
// ̒lY

#define EXT_TYPE_IMAGE		(10)								// 摜t@C
#define EXT_TYPE_SOUND		(30)								// t@C
#define EXT_TYPE_MOVIE		(50)								// t@C
#define EXT_TYPE_TEXT		(90)								// eLXgt@C
#define EXT_TYPE_ARCHIVE	(99)								// A[JCut@C

enum {															// et@CƂ̑Ή
	EXT_TYPE_JPG = 1,
	EXT_TYPE_PNG,
	EXT_TYPE_GIF,
	EXT_TYPE_BMP,
	EXT_TYPE_MP3 = EXT_TYPE_IMAGE,
	EXT_TYPE_WAVE,
	EXT_TYPE_AVI = EXT_TYPE_SOUND,
	EXT_TYPE_TXT = EXT_TYPE_MOVIE,
	EXT_TYPE_INI,
	EXT_TYPE_CFG,
	EXT_TYPE_ZIP = EXT_TYPE_TEXT,
	EXT_TYPE_RAR
};

//----- ϐ -----

typedef struct {
	int		padReverse;
	int		padCutoff;
	int		fileSort;					// 
	int		hbl;						// 
	int		keySwap;					// 
	int		bgmLoop;					// 
	int		sleep;						// 
	int		arcPass;					// A[JCũpX[hۑ邩 0:No
	int		seVol;						// SẺʁi0`100j
	char	imageDir[FILE_PATH];		// 
	char	bgmDir[FILE_PATH];			// 
} CONFIG;


typedef struct {
	CONFIG		cfg;
	char		cwDir[FILE_PATH];
	SceCtrlData	pad;
	SceCtrlData	oldPad;
	char		bgmFile[FILE_PATH];
	Color		BakCor;											// wiF
} S_2CH;

//----- vg^Cv錾 -----

void cursorMove(int *pos, int count, int min);
SceInt64 fileDivRead(SceUID fd, void *data, SceSize size);
SceInt64 fileDivWrite(SceUID fd, const void *data, SceSize size, char *errMsg);
int filePrefetchInit(iniList *ini);
SceUID filePrefetchOpen(const char *file);
int filePrefetchSeek(SceUID fd, int offset, int whence);
SceInt64 filePrefetchRead(SceUID fd, void *data, SceSize size);
void filePrefetchClose(SceUID fd);
void filePrefetchTerm();
void DoEvent();
int getThumbName(char *file2, char *file);
void writeArcPass(char *file, char *pass);
void readArcPass(char *pass, char *file);
char *expandToMem(char *file, DirList *DList, int *size);
int checkExt(char *path);
char *getExtName(int extType);
int getIconNo(char *path);
void getThumbPath(char *thumbPath, char *path, char *name2);

#endif
