//==============================================================
// 摜\C
//--------------------------------------------------------------

#ifndef __FV_VIEW__
#define __FV_VIEW__

typedef struct tagBITMAPFILEHEADER {
	unsigned char	bfType[2];
	unsigned long	bfSize;
	unsigned short	bfReserved1;
	unsigned short	bfReserved2;
	unsigned long	bfOffBits;
} __attribute__ ((packed)) BITMAPFILEHEADER;

typedef struct tagBITMAPINFOHEADER {
	unsigned long	biSize;
	long			biWidth;
	long			biHeight;
	unsigned short	biPlanes;
	unsigned short	biBitCount;
	unsigned long	biCompression;
	unsigned long	biSizeImage;
	long			biXPixPerMeter;
	long			biYPixPerMeter;
	unsigned long	biClrUsed;
	unsigned long	biClrImportant;
} __attribute__ ((packed)) BITMAPINFOHEADER;

typedef struct tagRGBQUAD {
	unsigned char	rgbBlue;
	unsigned char	rgbGreen;
	unsigned char	rgbRed;
	unsigned char	rgbReserved;
} __attribute__ ((packed)) RGBQUAD;

enum RET_TYPE
{
	COMPLETE,
	SAVE_ERR,
	CANCEL,
	SHIFT,
	HEAD_ERR = -0x8000000,
	LIB_ERR,
	DEC_ERR,
	MEM_ERR,
	SUP_ERR,
	FRM_ERR,
	OPEN_ERR,
	EXPAND_ERR,
	TEST_ERR
};

typedef struct {
	Color			**tex;										// X x Y eNX`ziNULL:C[Wj
	unsigned int	count;										// eNX`̑
	unsigned int	countX;										// eNX`X
	unsigned int	width;										// eNX`ŜłXTCY
	unsigned int	height;										// eNX`ŜłYTCY
	unsigned int	widthAlign;									// XŏIeNX`̃TCY
} strTex;

typedef struct {												// 摜\̏Ǘ
	int				reset;										// tOi0:ĂȂj
	strTex			orgTex1;									// 摜eNX`P
	strTex			orgTex2;									// 摜eNX`QiAj[VGIFpjigpj
	strTex			*orgTex;									// 摜eNX`i؂ւpj
	int				orgRange;									// eNX`̏k
	strTex			sdTex;										// 1/nꂽeNX`ikeNX`j
	int				sdRange;									// ۂ́ieʓIɗeFjkeNX`̏kni1, 2, 3 cj
	int				sdRangeSub;									// œKȁivZjkeNX`̏k
} strPicView;


void freeTexMem(strPicView *pv);
int imageView(char *path, DirList *DList, int *dFlag);
int imageDecode(strPicView *pv, int imageType, unsigned char *data, unsigned long length, int width, int height);
void texImageDraw(strPicView *pv, int x, int y, int width, int height, float alpha);

#endif
