//==============================================================
// RtBOt@C֘A
//--------------------------------------------------------------

#include "FreezeViewer.h"
#include "psp2chIni.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int				gSaveFlag;

extern S_2CH	s2ch;

//----- RtBO -----

strConfig	gConfig[CONFIGCOUNT] = {
	{ "CFG_PAD_REVERSE",  &s2ch.cfg.padReverse, 1 },
	{ "CFG_PAD_CUTOFF",   &s2ch.cfg.padCutoff,  35 },
	{ "CFG_FILE_SORT",    &s2ch.cfg.fileSort,   1 },
	{ "CFG_HBL",          &s2ch.cfg.hbl,        0 },
	{ "CFG_PAGEKEY_SWAP", &s2ch.cfg.keySwap,    0 },
	{ "CFG_BGM_LOOP",     &s2ch.cfg.bgmLoop,    0 },
	{ "CFG_SLEEP_TIME",   &s2ch.cfg.sleep,      10 },
	{ "CFG_ARCHIVE_PASS", &s2ch.cfg.arcPass,    1 },
	{ "CFG_SE_VOL",       &s2ch.cfg.seVol,      100 }
};

//----- ݒl擾 -----

#define setHex(A, B, C) \
    p = strstr(buf, (A));\
    if (p) {\
        p = strstr(p, "0x");\
        if(p){\
            p+=2;\
            (B) = strtol(p, NULL, 16);\
        }\
        else{(B) = (C);}\
    }\
    else{(B) = (C);}

#define setInt(A, B, C) \
    p = strstr(buf, (A));\
    if (p) {\
        p = strchr(p, '=');\
        if(p){\
            p++;\
            (B) = strtol(p, NULL, 10);\
            if ((B) < 0) (B) = 0;\
        }\
        else{(B) = (C);}\
    }\
    else{(B) = (C);}

#define setString(A, B, C, D) \
    p = strstr(buf2, (A));\
    if (p) {\
        p = strchr(p, '"');\
        if(p){\
            p++;\
            for (i = 0; *p != '"'; i++) {\
                if (i >= (D)) break;\
                (B)[i] = *p++;\
            }\
            (B)[i] = '\0';\
        }\
        else{strcpy((B), (C));}\
    }\
    else{strcpy((B), (C));}\


/***********************************
config.iniǂݍ
************************************/

void iniLoadConfig(void)
{
	SceUID		fd;
	SceIoStat	st;
	char		path[FILE_PATH];
	char		*buf, *buf2;
	char		*p;
	int			i, j;

	gSaveFlag = 0;												// XV邩Hi0:Noj
	sprintf( path, "%s/config.ini", s2ch.cwDir );
	i = sceIoGetstat( path, &st );
	if (i >= 0) {
		buf = (char*)malloc( st.st_size + 1 );
		if (buf) {
			fd = sceIoOpen( path, PSP_O_RDONLY, FILE_PARMISSION );
			if (fd >= 0) {
				fileDivRead( fd, buf, st.st_size );
				sceIoClose( fd );
				buf[st.st_size] = '\0';
				buf2 = buf;
				for (j = 0; j < CONFIGCOUNT; j++) {
					setInt( gConfig[j].name, *gConfig[j].val, gConfig[j].defVal );
				}
				if (s2ch.cfg.bgmLoop > 4) s2ch.cfg.bgmLoop = 4;
				setHex( "CFG_BACK_COLOR", s2ch.BakCor, 0x00104010 );	// wiF
				setString( "CFG_IMAGE_DIR", s2ch.cfg.imageDir, "ms0:/PICTURE", FILE_PATH );
				setString( "CFG_BGM_DIR", s2ch.cfg.bgmDir, "ms0:/MUSIC", FILE_PATH );
				free( buf );
				return;

			} else {
				free( buf );
			}
		}
	}

	//--- ftHgݒ ---

	s2ch.cfg.padReverse = 1;									// pbḧړ(0:Ώۂړ, 1:_ړ)
	s2ch.cfg.padCutoff = 35;									// AiOpbh̃j[gђl
	s2ch.cfg.fileSort = 1;										// t@C[Ńt@C\[g邩
	s2ch.cfg.hbl = 0;											// HBLœ
	s2ch.cfg.keySwap = 0;										// 摜L[ւ
	s2ch.cfg.bgmLoop = 0;										// BGM[vݒ
	s2ch.cfg.sleep = 10;										// TXyh
	s2ch.cfg.arcPass = 1;										// A[JCupX[hۑ
	s2ch.cfg.seVol = 100;										// SE(0`100)
	s2ch.BakCor = 0x00104010;									// wiF
	strcpy( s2ch.cfg.imageDir, "ms0:/PICTURE" );				// 摜tH_
	strcpy( s2ch.cfg.bgmDir, "ms0:/MUSIC" );					// BGMtH_
}


//==============================================================
// RtBOt@CXV
//--------------------------------------------------------------

//===== RtBOe =====
// buf  : RtBOt@Ce
// size : buff[^̃TCYωꍇAω̃TCY鎖
// name : RtBOږ
// val  : ݒl
//----------------------------------
// w肳ꂽRtBOڂTA̐ݒlB
// ꍇɂĂ̓RtBOt@CẽTCY傫ȂꍇB
// sRg'#''/'ȍ~
//----------------------------------

static void configSet(char *buf, int *size, char *name, int val)
{
	char	*p, *p2;
	char	valStr[255], *retStr;
	int		step, valSize;

	p = strstr( buf, name );
	if (p) {													// ڔ
		p = strchr( p, '=' );
		if (p) {
			p++;
			p2 = p;
			while (*p2!='\t' && *p2!='\r' && *p2!='\n' && *p2!='#' && *p2!='/' && *p2!='\0') {
				*p2 = ' ';										// ݒlLqʒuNA
				p2++;
			}
			step = p2 - p;										// ݒlLqʒũTCY
			sprintf( valStr, "%d", val );
			if (*p2=='#' || *p2=='/') {							// sRgLȂ
				valSize = strlen(valStr) + 2;
			} else {											// Rg
				valSize = strlen(valStr) + 1;
			}
			if (step < valSize) {								// ݒlLqʒũTCYȂ
				memmove( &p[valSize-step], p, *size - (p - buf) );
				*size += valSize - step;
			}
			p++;
			strncpy( p, valStr, strlen(valStr) );				// ݒlC
		}
	} else {													// Yڂ݂Ȃ
		sprintf( valStr, "%s = %d", name, val );
		if (strchr(buf,'\r')) {									// sR[hI
			retStr = "\r\n";
		} else {
			retStr = "\n";
		}
		strcat( valStr, retStr );
		if (*size != 0 && buf[(*size)-1] != '\n') {				// ŏIssŏIĂȂ
			strcat( buf, retStr );								// sǉ
			*size += strlen( retStr );
		}
		strcat( buf, valStr );									// RtBOڂǉ
		*size += strlen( valStr );
	}
}

//===== C =====

void iniSaveConfig(void)
{
	SceUID		fd;
	SceIoStat	st;
	char		path[FILE_PATH];
	char		*buf;
	int			i, size;

	if (!gSaveFlag) return;										// XVtOĂȂȂI

	sprintf( path, "%s/config.ini", s2ch.cwDir );				// RtBOt@Cʒu
	if (sceIoGetstat(path, &st) >= 0) {							// RtBOt@CȂۑȂ
		size = st.st_size;
		buf = (char*)malloc( size + 1024 );						// sǉꍇ̂
		if (buf) {
			fd = sceIoOpen( path, PSP_O_RDWR, FILE_PARMISSION);
			if (fd >= 0) {
				fileDivRead( fd, buf, size );
				buf[size] = '\0';
				for (i = 0; i < CONFIGCOUNT; i++) {
					configSet( buf, &size, gConfig[i].name, *gConfig[i].val );
				}
				sceIoLseek( fd, 0, PSP_SEEK_SET );				// 擪ʒuɃV[N
				fileDivWrite( fd, buf, size, path );
				sceIoClose( fd );
			}
			free( buf );
		}
	}
}

//==============================================================
// RtBOt@CXVv
//--------------------------------------------------------------

void iniSetSaveFlag(void)
{
	gSaveFlag = 1;												// XV邩Hi1:Yesj
}

