/*
* $Id$
*/

#include "FreezeViewer.h"
#include "fvTool.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


extern S_2CH s2ch; // psp2ch.c

#define setHex(A, B, C) \
    p = strstr(buf, (A));\
    if (p) {\
        p = strstr(p, "0x");\
        if(p){\
            p+=2;\
            (B) = strtol(p, NULL, 16);\
        }\
        else{(B) = (C);}\
    }\
    else{(B) = (C);}

#define setInt(A, B, C) \
    p = strstr(buf, (A));\
    if (p) {\
        p = strchr(p, '=');\
        if(p){\
            p++;\
            (B) = strtol(p, NULL, 10);\
        }\
        else{(B) = (C);}\
    }\
    else{(B) = (C);}

#define setString(A, B, C, D) \
    p = strstr(buf2, (A));\
    if (p) {\
        p = strchr(p, '"');\
        if(p){\
            p++;\
            for (i = 0; *p != '"'; i++) {\
                if (i >= (D)) break;\
                (B)[i] = *p++;\
            }\
            (B)[i] = '\0';\
        }\
        else{strcpy((B), (C));}\
    }\
    else{strcpy((B), (C));}\

/***********************************
config.iniǂݍ
************************************/
void psp2chIniLoadConfig(void)
{
    SceUID fd;
    SceIoStat st;
    char path[FILE_PATH];
    char *buf, *buf2;
    char *p;
    int i, j;

    sprintf(path, "%s/config.ini", s2ch.cwDir);
    i = sceIoGetstat(path, &st);
    if (i >= 0)
    {
        buf = (char*)malloc(st.st_size + 1);
        if (buf)
        {
            fd = sceIoOpen(path, PSP_O_RDONLY, FILE_PARMISSION);
            if (fd >= 0)
            {
                psp2chFileRead(fd, buf, st.st_size);
                sceIoClose(fd);
                buf[st.st_size] = '\0';
                buf2 = buf;
                setInt("CFG_PAD_REVERSE", s2ch.cfg.padReverse, 1);
                setInt("CFG_PAD_ACCEL", s2ch.cfg.padAccel, 1);
                setInt("CFG_PAD_CUTOFF", s2ch.cfg.padCutoff, 35);
				setInt("CFG_FILE_SORT", s2ch.cfg.fileSort, 1);		// t@C[Ńt@C\[g邩
				setInt("CFG_HBL", s2ch.cfg.hbl, 0);					// HBLœ
				setInt("CFG_INPUT_TYPE", s2ch.cfg.inputType, 0);	// ̓_CAO̎
				setInt("CFG_PAGEKEY_SWAP", s2ch.cfg.keySwap, 0);	// 摜L[ւ
				setInt("CFG_BGM_LOOP", s2ch.cfg.bgmLoop, 1);		// BGM[vݒ
				if (s2ch.cfg.bgmLoop > 3) s2ch.cfg.bgmLoop = 3;
				setInt("CFG_SLEEP_TIME", s2ch.cfg.sleep, 10);		// TXyh
				setInt("CFG_ARCHIVE_PASS", s2ch.cfg.arcPass, 1);	// A[JCupX[hۑ邩
				setHex("CFG_BACK_COLOR", s2ch.BakCor, 0x00104010);	// wiF
                setString("CFG_IMAGE_DIR", s2ch.cfg.imageDir, "ms0:/PICTURE", FILE_PATH);
				setString("CFG_BGM_DIR", s2ch.cfg.bgmDir, "ms0:/MUSIC", FILE_PATH);
                free(buf);
                return;
            }
            else
            {
                free(buf);
            }
        }
    }
    s2ch.cfg.padReverse = 1;		// pbḧړ(1:Ώۂړ,-1:_ړ)
    s2ch.cfg.padAccel = 1;			// 0:2iK, 1:8iK
    s2ch.cfg.padCutoff = 35;		// AiOpbh̃j[gђl
	s2ch.cfg.fileSort = 1;			// t@C[Ńt@C\[g邩
	s2ch.cfg.hbl = 0;				// HBLœ
	s2ch.cfg.inputType = 0;			// ̓_CAO̎
	s2ch.cfg.keySwap = 0;			// 摜L[ւ
	s2ch.cfg.bgmLoop = 1;			// BGM[vݒ
	s2ch.cfg.sleep = 10;			// TXyh
	s2ch.cfg.arcPass = 1;			// A[JCupX[hۑ
	s2ch.BakCor = 0x00104010;		// wiF
    strcpy(s2ch.cfg.imageDir, "ms0:/PICTURE");					// 摜tH_
	strcpy(s2ch.cfg.bgmDir, "ms0:/MUSIC");						// BGMtH_
}

