//==============================================================
// TEh֘A
//--------------------------------------------------------------
// ʉǂݍ݁AAvŗpo悤ɂ܂B
//--------------------------------------------------------------

#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <pspkernel.h>
#include <pspaudiolib.h>
#include <pspiofilemgr.h>

#include "FreezeViewer.h"
#include "fvTool.h"
#include "BGM.h"
#include "sound.h"

//----- 萔ݒ -----

#define SOUNDFOLDER		"sound/"								// SEt@CtH_
#define MIXCHANNEL		(5)										// 

//----- SEf[^ -----

typedef struct {												// SEf[^Ǘp
	u32		*pData;
	u32		count;
} strSE;

static strSE	gSE[eSE_count];									// SEf[^

//----- Đf[^ -----

typedef struct {
	volatile u32	*pData;										// ݍĐĂ鉹f[^ւ̃|C^
	volatile u32	count;										// cTv
} strPData;

static strPData		gPData[MIXCHANNEL];							// Đ̉f[^Ǘp

struct wavUnit {
	s16		l;
	s16		r;
};
union wavs {
	struct wavUnit	lr;
	u32				wav;
};

//----- OQ -----

extern S_2CH s2ch;												// fvTool.c


//==============================================================
// SE̒~
//--------------------------------------------------------------

static void se_stop(void)
{
	int		i;

	for (i = 0; i < MIXCHANNEL; i++) {
		gPData[i].pData = NULL;
		gPData[i].count = 0;
	}
}


//==============================================================
// SE̎w
//--------------------------------------------------------------
// ĐSEw肵܂B
// w肵uԂSE̍Đn܂܂B
// 𒴂SEoƂꍇ͉o܂B
//--------------------------------------------------------------

void sound_play(enum eSE SEno)
{
	int		i;

	for (i = 0; i < MIXCHANNEL; i++) {
		if (gPData[i].pData == NULL) {
			gPData[i].pData = gSE[SEno].pData;
			gPData[i].count = gSE[SEno].count;
			break;
		}
	}
}


//==============================================================
// C
//--------------------------------------------------------------

static void audioCallback(void *buf, unsigned int length, void *userdata)
{
	union wavs	wavS, wavD;
	u32		i, j, *pbuf;
	s32		data;

	pbuf = (u32*)buf;
	for (i = 0; i < length; i++) {
		pbuf[i] = 0;
	}
	for (j = 0; j < MIXCHANNEL; j++) {
		for (i = 0; i < length; i++) {
			if (gPData[j].pData != NULL) {
				wavD.wav = pbuf[i];
				wavS.wav = *gPData[j].pData++;
				data = wavD.lr.l;
				data += wavS.lr.l;
				if (data >  32767) data = 32767;
				if (data < -32767) data = -32767;
				wavD.lr.l = (s16)data;							// L~bNX
				data = wavD.lr.r;
				data += wavS.lr.r;
				if (data >  32767) data = 32767;
				if (data < -32767) data = -32767;
				wavD.lr.r = (s16)data;							// R~bNX
				pbuf[i] = wavD.wav;
				gPData[j].count--;
				if (gPData[j].count <= 0) {
					gPData[j].count = 0;
					gPData[j].pData = NULL;
				}
			}
		}
	}
	if (s2ch.cfg.seVol < 0) s2ch.cfg.seVol = 0;
	if (s2ch.cfg.seVol > 100) s2ch.cfg.seVol = 100;
	for (i = 0; i < length; i++) {
		wavD.wav = pbuf[i];
		wavD.lr.l *= (float)s2ch.cfg.seVol / 100;
		wavD.lr.r *= (float)s2ch.cfg.seVol / 100;
		pbuf[i] = wavD.wav;
	}
}


//==============================================================
// wavt@Cǂݍ
//--------------------------------------------------------------
// ߂lF 0 I
//         <0 G[
//--------------------------------------------------------------
// wavt@CĐp`ɕϊēǂݍ݂܂B
// t@C̓jAPCMɂ̂ݑΉB
//--------------------------------------------------------------

static int wavLoad(strSE *SE, char *path, char *errMsg)
{
	int	ret;

	ret = wavFileDecode( path, &SE->pData, &SE->count );
	if (ret < 0) {
		switch (ret) {
		case -1:
			sprintf( errMsg, "(%s) t@CANZXŃG[܂", path );
			break;
		case -2:
			strcpy( errMsg, "mۂɎs܂" );
			break;
		case -3:
			strcpy( errMsg, "ΉĂȂ`̃t@Cł" );
			break;
		}
	}
	return ret;
}

//==============================================================
// ZbgAbv
//--------------------------------------------------------------
// ߂lF0 I
//--------------------------------------------------------------
// `l0SEpƂĎgp܂B
//--------------------------------------------------------------

int soundInit(iniList *ini)
{
	const char	*seFile[] = { "move.wav", "back.wav", "open.wav", "bell.wav" };
	char		path[FILE_PATH];
	int			err, i;

	se_stop();
	s2ch.cfg.seVol = 100;

	pspAudioInit();
	pspAudioSetVolume( 0, PSP_VOLUME_MAX, PSP_VOLUME_MAX );
	pspAudioSetChannelCallback( 0, audioCallback, NULL );

	err = 1;
	for (i = 0; i < eSE_count; i++) {
		strcpy( path, SOUNDFOLDER );
		strcat( path, seFile[i] );
		err = wavLoad( &gSE[i], path, ini->msg[ini->phase] );
		if (err) break;											// G[璆~
	}
	return err;
}


//==============================================================
// I
//--------------------------------------------------------------
// ǂݍ񂾉t@Cf[^܂B
//--------------------------------------------------------------

void sound_free(void)
{
	int		i;

	se_stop();

	for (i = 0; i < eSE_count; i++ ) {
		free( gSE[i].pData );
	}
}

