#include "rar.hpp"
#include "find.hpp"
#include "filefn.hpp"
#include "pathfn.hpp"
#include "unicode.hpp"

bool FileExist(const char *Name)
{
#ifdef ENABLE_ACCESS
  return(access(Name,0)==0);
#else
  struct FindData FD;
  return(FindFile::FastFind(Name, NULL, &FD));
#endif
}

bool IsDir(uint Attr)
{
  return((Attr & 0xF000)==0x4000);
}

bool IsLink(uint Attr)
{
  return((Attr & 0xF000)==0xA000);
}

void ConvertNameToFull(const char *Src,char *Dest)
{
  char FullName[NM];
  if (IsPathDiv(*Src) || IsDiskLetter(Src))
    strcpy(FullName,Src);
  else
  {
    getcwd(FullName,sizeof(FullName));
    AddEndSlash(FullName);
    strcat(FullName,Src);
  }
  strcpy(Dest,FullName);
}
