//==============================================================
// 摜\C
//--------------------------------------------------------------

#ifndef __FV_VIEW__
#define __FV_VIEW__

typedef struct tagBITMAPFILEHEADER {
	unsigned char	bfType[2];
	unsigned long	bfSize;
	unsigned short	bfReserved1;
	unsigned short	bfReserved2;
	unsigned long	bfOffBits;
} __attribute__ ((packed)) BITMAPFILEHEADER;

typedef struct tagBITMAPINFOHEADER {
	unsigned long	biSize;
	long			biWidth;
	long			biHeight;
	unsigned short	biPlanes;
	unsigned short	biBitCount;
	unsigned long	biCompression;
	unsigned long	biSizeImage;
	long			biXPixPerMeter;
	long			biYPixPerMeter;
	unsigned long	biClrUsed;
	unsigned long	biClrImporant;
} __attribute__ ((packed)) BITMAPINFOHEADER;

typedef struct tagRGBQUAD {
	unsigned char	rgbBlue;
	unsigned char	rgbGreen;
	unsigned char	rgbRed;
	unsigned char	rgbReserved;
} __attribute__ ((packed)) RGBQUAD;

enum RET_TYPE
{
	COMPLETE,
	SAVE_ERR,
	CANCEL,
	SHIFT,
	HEAD_ERR = -0x8000000,
	LIB_ERR,
	MEM_ERR,
	SUP_ERR,
	FRM_ERR,
	OPEN_ERR,
	EXPAND_ERR,
	TEST_ERR
};

int imageView(char *path, DirList *DList, int *dFlag);

#endif
