//==============================================================
// BGMt@CĐ
//--------------------------------------------------------------

#ifndef __FV_AUDIO_H__
#define __FV_AUDIO_H__

#include "fvView.h"

typedef struct {
	int				type;										// ̎ށi1:mp3 2:wavej
	int				bgmID;										// ȕύXʁiȂςCNgj
	int				tag;										// ^O̎ށi1:ID3v1 2:ID3v2.2 3:ID3v2.3 4:ID3v2.4j
	unsigned char	title[129];
	unsigned char	artist[129];
	unsigned char	album[129];
	unsigned char	year[5];
	unsigned char	comment[129];
	unsigned int	pos;										// V[Nʒu
	unsigned int	time;										// Ȃ̒i0.01sj
	int				SamplingRate;								// TvO[g
	int				bitRate;									// rbg[g
	int				mLayer;										// C[i1 = Layer-V,  2 = Layer-U,  3 = Layer-Tj
	int				mID;										// 0 = MPEG2, 1 = MPEG1
	int				channel;									// `li0:XeI 1:WCgXeI 2:fA`l 3:mj
	int				vbr;										// σrbg[gi0:No 1:YESj
	unsigned int	frame;										// t[
	int				imageType;									// WPbg摜̎ށi0: 1:jpeg 2:pngj
	unsigned char	*data;										// WPbg摜̈kf[^
	long			dataSize;									// kf[^TCY
	char			mode;										// BGMWPbg摜Xbhւ̃R}hw
	strPicView		pv;											// WJꂽWPbg摜
	int				pvFlag;										// WPbg摜Li0:j
	int				infoFlag;									// ڍ׏\邩i0:Noj
	char			*info;										// ڍ׏
} strBgm;

extern volatile strBgm gBGM;

void bgmPropertyClear(strBgm *bgm);
void getMP3FileTag(SceUID fd, strBgm *bgm, int *start, int *end);
int audioInit(iniList *phase);
void audioTerm(void);
int audioPlay(const char *path, const char *name);
void audioStop(void);
void audioNext(void);
void audioBack(void);
void audioReplay(void);
int audioGetPlayMode(void);

#endif
