#ifndef _RAR_UNICODE_
#define _RAR_UNICODE_

bool WideToChar(const wchar *Src,char *Dest,int DestSize=0x1000000);
bool CharToWide(const char *Src,wchar *Dest,int DestSize=0x1000000);
byte* WideToRaw(const wchar *Src,byte *Dest,int DestSize=0x1000000);
wchar* RawToWide(const byte *Src,wchar *Dest,int DestSize=0x1000000);
void UtfToWide(const char *Src,wchar *Dest,int DestSize);

int strlenw(const wchar *str);
wchar* strcpyw(wchar *dest,const wchar *src);
wchar* strncpyw(wchar *dest,const wchar *src,int n);
wchar* strcatw(wchar *dest,const wchar *src);
int strcmpw(const wchar *s1,const wchar *s2);
int strncmpw(const wchar *s1,const wchar *s2,int n);
int stricmpw(const wchar *s1,const wchar *s2);
int strnicmpw(const wchar *s1,const wchar *s2,int n);
wchar *strchrw(const wchar *s,int c);
wchar* strrchrw(const wchar *s,int c);
wchar* strpbrkw(const wchar *s1,const wchar *s2);
wchar* strlowerw(wchar *Str);
wchar* strupperw(wchar *Str);
int atoiw(const wchar *s);

#define charnext(s) ((s)+1)
#define strlend strlen
#define strchrd strchr
#define strrchrd strrchr

#endif
